﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.ServiceModel;
using System.ServiceModel.Description;

using ClassLibrary;
using System.ServiceModel.Discovery;

namespace Server
{
    class ServerClass
    {
        protected static List<ServiceHost> Hosts;
        protected static List<string> Urls;
        protected static int Port = 9001;
        public static void Start()
        {
            string name = Dns.GetHostName();
            IPAddress[] ipAddresses = Dns.GetHostAddresses(name);
            Hosts = new List<ServiceHost>();
            Urls = new List<string>();
            for (int i = 0; i < ipAddresses.Length; i++)
            {
                if (ipAddresses[i].AddressFamily == System.Net.Sockets.AddressFamily.InterNetwork)
                {
                    string urlString = "net.tcp://" + ipAddresses[i].ToString() + ":" + Port.ToString() + "/Chat";
                    Urls.Add(urlString);
                    Uri url = new Uri(urlString);
                    ServiceHost host = new ServiceHost(typeof(Chat), url);
                    NetTcpBinding bind = new NetTcpBinding();                    
                    bind.Security.Mode = SecurityMode.None;
                    host.AddServiceEndpoint(typeof(Chat), bind, "");
                    ServiceMetadataBehavior sb = new ServiceMetadataBehavior();
                    host.Description.Behaviors.Add(sb);
                    host.AddServiceEndpoint(typeof(IMetadataExchange), MetadataExchangeBindings.CreateMexTcpBinding(), "mex");
                    host.AddServiceEndpoint(new UdpDiscoveryEndpoint());
                    ServiceDiscoveryBehavior db = new ServiceDiscoveryBehavior();
                    host.Description.Behaviors.Add(db);

                    try{
                        host.Open();
                        Hosts.Add(host);
                    }
                    catch(Exception e)
                    {
                    }
                }
            }            
        }
        public static void Stop()
        {
            foreach (ServiceHost host in Hosts)
            {
                if (host.State == CommunicationState.Opened)
                  host.Close();
            }
        }
        public static List<string> GetUrls()
        {
            return Urls;
        }
    }
}
